/*
    Texel - A UCI chess engine.
    Copyright (C) 2013-2014  Peter Österlund, peterosterlund2@gmail.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/*
 * stloutput.hpp
 *
 *  Created on: Dec 24, 2013
 *      Author: petero
 */

#ifndef STLOUTPUT_HPP_
#define STLOUTPUT_HPP_

#include <iostream>
#include <vector>
#include <set>

template <typename T>
std::ostream& operator<<(std::ostream& os, const std::vector<T>& v) {
    os << "[ ";
    bool first = true;
    for (const T& e : v) {
        if (!first)
            os << ", ";
        os << e;
        first = false;
    }
    os << " ]";
    return os;
}

template <typename T, typename Comp>
std::ostream& operator<<(std::ostream& os, const std::set<T, Comp>& c) {
    os << "{";
    bool first = true;
    for (const T& e : c) {
        if (!first)
            os << ", ";
        os << e;
        first = false;
    }
    os << " }";
    return os;
}

#endif /* STLOUTPUT_HPP_ */
